## shell-generic-container shell-generic-container — A container class with signals for allocation |

## Functions

guint | shell_generic_container_get_n_skip_paint ()
gboolean | shell_generic_container_get_skip_paint ()
void | shell_generic_container_set_skip_paint ()

## Types and Values

#define | SHELL_TYPE_GENERIC_CONTAINER
| ShellGenericContainer

## Description

ShellGenericContainer is mainly a workaround for the current lack of GObject subclassing + vfunc overrides in gjs. We implement the container interface, but proxy the virtual functions into signals, which gjs can catch.

ShellGenericContainer is an StWidget, and automatically takes its borders and padding into account during size request and allocation.

## Functions

### shell_generic_container_get_n_skip_paint ()

    guint
    shell_generic_container_get_n_skip_paint
                                   (ShellGenericContainer *self);

#### Parameters

self | A ShellGenericContainer |

#### Returns

Number of children which will not be painted.

### shell_generic_container_get_skip_paint ()

    gboolean
    shell_generic_container_get_skip_paint
                                   (ShellGenericContainer *self,
                                    ClutterActor *child);

Gets whether or not `actor` is skipped when painting.

#### Parameters

self | A ShellGenericContainer |
child | Child ClutterActor |

#### Returns

`TRUE` or `FALSE`

### shell_generic_container_set_skip_paint ()

    void
    shell_generic_container_set_skip_paint
                                   (ShellGenericContainer *self,
                                    ClutterActor *child,
                                    gboolean skip);

Set whether or not we should skip painting `actor` . Workaround for lack of gjs ability to override _paint vfunc.

#### Parameters

self | A ShellGenericContainer |
child | Child ClutterActor |
skip | `TRUE` if we should skip painting |

## Types and Values

### SHELL_TYPE_GENERIC_CONTAINER

    #define SHELL_TYPE_GENERIC_CONTAINER (shell_generic_container_get_type ())

### ShellGenericContainer

    typedef struct _ShellGenericContainer ShellGenericContainer;